package de.mfuchs.xmlstorage;

import java.math.BigDecimal;


/**
 * AbstractXMLNode is the base class of XMLNode and XMLStreamNode.
 * @author martin
 */
public abstract class AbstractXMLNode
{
	public abstract String getName();

	/// read only access to an attribute
	public abstract String get(final String attrName);

	/// read only access to an attribute with default value
	public abstract String get(final String attrName, final String def);

	public abstract String getContent();

	public abstract String toString();

	public XMLInt getInt(final String attrName)
	{
	    return new XMLInt(this, attrName);
	}
	public XMLInt getInt(final String attrName, int def)
	{
	    return new XMLInt(this, attrName, def);
	}

	public XMLNumber getNumber(final String attrName)
	{
	    return new XMLNumber(this, attrName);
	}
	public XMLNumber getNumber(final String attrName, BigDecimal def)
	{
	    return new XMLNumber(this, attrName, def);
	}

	public XMLBool getBool(final String attrName)
	{
	    return new XMLBool(this, attrName);
	}
	public XMLBool getBool(final String attrName, boolean def)
	{
	    return new XMLBool(this, attrName, def);
	}

	public XMLString getString(final String attrName)
	{
	    return new XMLString(this, attrName);
	}
	public XMLString getString(final String attrName, final String def)
	{
	    return new XMLString(this, attrName, def);
	}
}
