
//
// XML storage classes version 1.2
//
// XMLChildrenFilter.java
//
// Copyright (c) 2004, 2005, 2007 Martin Fuchs <martin-fuchs@gmx.net>
//


/*

 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright
	notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
	notice, this list of conditions and the following disclaimer in
	the documentation and/or other materials provided with the
	distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.

*/

package de.mfuchs.xmlstorage;


/**
 * XMLChildrenFilter provides iterator access to XMLStorage child nodes
 * with name filtering.
 */
public final class XMLChildrenFilter implements Iterable<XMLNode>
{
   	public XMLChildrenFilter(XMLNode.Children children, final String name)
   	{
   	 	_iterator = new XMLFilterIterator<XMLNode>(children.iterator(), name);
   	}

   	public XMLChildrenFilter(XMLNode node, final String name)
   	{
   	    _iterator = new XMLFilterIterator<XMLNode>(node.getChildren().iterator(), name);
   	}

   	public XMLChildrenFilter(XMLPos pos, final String name)
   	{
   	    _iterator = new XMLFilterIterator<XMLNode>(pos.cur().getChildren().iterator(), name);
   	}

   	public XMLFilterIterator<XMLNode> iterator()
   	{
   		return _iterator;
   	}

   	private XMLFilterIterator<XMLNode>	_iterator;
}
